#define Track1_Length				120	// 79 + 1
#define Track2_Length				120	// 39 + 1
#define Track3_Length				120 // 106 + 1

//
// BOOL SetTrack23Standard(USHORT nTrack2Standard,USHORT nTrack3Standard);
//
#define	SET_TRACK_TO_STANDARD1		0x01
#define	SET_TRACK_TO_STANDARD2		0x02
#define	SET_TRACK_TO_STANDARD3		0x03
#define	SET_TRACK_TO_STANDARD4		0x04
#define	SET_TRACK_TO_STANDARD5		0x05
#define	SET_TRACK_TO_STANDARD6		0x06
#define	SET_TRACK_TO_STANDARD7		0x07 // ( Default )
#define	SET_TRACK_TO_STANDARD8		0x08

//
// BOOL SetStartPosition(USHORT nStartPosition);
//
#define START_POSITION_16BIT		0x01
#define START_POSITION_20BIT		0x02
#define START_POSITION_22BIT		0x03 // ( Default )
#define START_POSITION_25BIT		0x04

//
// BOOL SelectCharSet(USHORT nCharSet);
//
#define	CHAR_SET1					0x01 // IBM 1
#define	CHAR_SET2					0x02 // IBM 2
#define	CHAR_SET3					0x03 // IBM 3
#define	CHAR_SET4					0x04 // ISO ( Default )

class SCW2750UEncoder
{
private:
	HANDLE hSCW2750U;

public:
	UCHAR chPosition;
	UCHAR chCharSet;
	UCHAR chTrack2Standard;
	UCHAR chTrack3Standard;

	// Encoder connect...
	BOOL __declspec (dllexport) __stdcall Connect();

	// Encoder disconnect...
	VOID __declspec (dllexport) __stdcall Disconnect();

	// Initial Encoder
	BOOL __declspec (dllexport) __stdcall InitialReader();

	// Let Encoder Beep
	BOOL __declspec (dllexport) __stdcall Beep();

	// Detect Encoder online
	BOOL __declspec (dllexport) __stdcall QueryReaderState();

	// Get Encoder Setting
	BOOL __declspec (dllexport) __stdcall GetEncoderSetting();

	// if n75BPI is true , the Track2 will 75 BPI encode
	// if n75BPI is false , the Track2 will 210 BPI encode
	BOOL __declspec (dllexport) __stdcall SetTrack2_75BPI(BOOL n75BPI);

	// Set Track2 and Track3 Standard
	BOOL __declspec (dllexport) __stdcall SetTrack23Standard(USHORT nTrack2Standard,USHORT nTrack3Standard);

	// Set Track R/W Start Position
	BOOL __declspec (dllexport) __stdcall SetStartPosition(USHORT nStartPosition);

	// Set Track R/W Char Set
	BOOL __declspec (dllexport) __stdcall SelectCharSet(USHORT nCharSet);

	// if m_Track1Enable is true , than read Track1 Data 
	// if m_Track2Enable is true , than read Track2 Data 
	// if m_Track3Enable is true , than read Track3 Data 
	BOOL __declspec (dllexport) __stdcall ReadTrack(BOOL nTrack1Read,BOOL nTrack2Read,BOOL nTrack3Read);

	// if Magnetic Card read
	// The Track1 Data will stored in nTrack1Data
	// The Track2 Data will stored in nTrack2Data
	// The Track3 Data will stored in nTrack3Data
	BOOL __declspec (dllexport) __stdcall ReadyToRead(UCHAR* nTrack1Data,UCHAR* nTrack2Data,UCHAR* nTrack3Data);

	// Send Data to Encoder
	BOOL __declspec (dllexport) __stdcall WriteTrack(UCHAR* nTrack1Data,UCHAR* nTrack2Data,UCHAR* nTrack3Data);

	// Let Encoder ready to Write
	BOOL __declspec (dllexport) __stdcall ReadyToWrite();

	// if Encoder write ok , than return true
	BOOL __declspec (dllexport) __stdcall WriteFinish();

	// Cancel Command
	BOOL __declspec (dllexport) __stdcall CancelCommand();
};